QGIS Application - Bug report #15737

Editing a form opened via openFeatureForm crashes qgis

2016-10-21 02:34 AM - Regis Haubourg

Status: Closed

Priority: Severe/Regression
Assignee:

Category: Forms

Affected QGIS version:master 2
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corruptsdata:

Regression?: No
Easy fix?: No
Resolution:

Copied to github as #: 23659

Description

Hi,

on 2.16.3 (either compiled or from binaries) and master 7d00cae4bbb723aaf4a2c1e51a9a485c402bc180 (23th of september)

| open a form using openFeatureForm(layer, feature) from python action. Validating the form will crash qgis at first attempt.

This is NOT related to Ul form, | get the crash with Autogenerated or drag and drop form.

Python action definition used to launch the edit form is:

registry = QgsMapLayerRegistry.instance()
layer = registry.mapLayer('[% @layer_id %]')

request = QgsFeatureRequest().setFilterFid([% $id %))

feature = next(layer.getFeatures(request))
qgis.utils.iface.openFeatureForm(layer, feature, 0, 1)

Using Hotlink plugin to trigger the same action leads to the same too.

gdb trace here : [[http://pastebin.com/LCOKaW5q]]

a sample project + data to reproduce is attached to the ticket

| declare it as regression since it has been working since early 2.x for me.

Associated revisions

Revision 9ecdf610 - 2016-10-28 11:17 AM - Hugo Mercier

Don't delete QgsAttributeDialog too early. Fixes #15737

Revision 91661421 - 2016-10-28 02:26 PM - Hugo Mercier

Merge pull request #3688 from mhugo/fix_15737

Don't delete QgsAttributeDialog too early. Fixes #15737

Revision 9f228d4b - 2016-10-28 03:09 PM - Hugo Mercier

2025-04-27

12



http://pastebin.com/LC0KaW5q

Don't delete QgsAttributeDialog too early. Fixes #15737

(cherry picked from commit 9ecdf6101433)

Revision 1e6b5eb4 - 2016-10-28 03:13 PM - Hugo Mercier

Don't delete QgsAttributeDialog too early. Fixes #15737

History

#1 - 2016-10-21 04:04 AM - Regis Haubourg

It seems that only osgeo4w is not affected

#2 - 2016-10-27 08:52 AM - Hugo Mercier

If you call openFeatureForm with modal = False, it does not crash

qgis.utils.iface.openFeatureForm(layer, feature, False, False)

#3 - 2016-10-27 09:01 AM - Regis Haubourg

Confirmed!

you gave me a nice workaround, thanks.

#4 - 2016-10-27 09:21 AM - Hugo Mercier

Ok, there is something strange around QgsAttributeDialog::show that is overloaded. It forces the dialog to be deleted on closing.

Then when the feature is accessed, the dialog is dead.

https://github.com/qgis/QGIS/blob/master/src/app/qgsfeatureaction.cpp#L125

#5 - 2016-10-28 05:26 AM - Hugo Mercier
- Status changed from Open to Closed

Fixed in changeset commit:"91661421814df138aa62a092aed0573e01840ea7".

Files

CRASH_FORM_via_openFeatureForm.zip 1.13 MB 2016-10-21 Regis Haubourg
